/*
*  PgpCache.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpCache.h"
#include "fileman.h"
#include "pgp.h"
#include "global.h"
//---------------------------------------------------------------------------
TPassphrase *Passphrase;
//---------------------------------------------------------------------------
__fastcall TPassphrase::TPassphrase(TComponent *Owner)
{
   Timer = new TTimer(Owner);
   Timer->Enabled = false;
   Timer->Interval = 1000;
   Timer->OnTimer = TimerTimer;
   phrases = new TStringList();
   sessionKey = NULL;
   seconds = 0;
}
//---------------------------------------------------------------------------
__fastcall TPassphrase::~TPassphrase()
{
   Clear();
   delete phrases;
   delete Timer;
}
//---------------------------------------------------------------------------
char*__fastcall TPassphrase::GetSessionKey()
{
   if (!sessionKey) sessionKey =
      (char*)ActMainForm->Perform(WM_GETSESSIONKEY,0,0);
   return sessionKey;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::TimerTimer(TObject *Sender)
{
   seconds--; if (seconds<=0) Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Clear()
{
   Timer->Enabled = false; seconds = 0;
   for (int i=0; i<phrases->Count; i++)
      delete (TDataBuf*)phrases->Objects[i];
   phrases->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Add(AnsiString idtext8, AnsiString phrase)
{
   Timer->Enabled = false;
   seconds = KEEPPASSWORDMIN*60;
   if (seconds<1) return;

   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   Delete(idtext8);

   TDataBuf *phrasebuf = new TDataBuf(phrase.c_str(),phrase.Length());
   phrasebuf->sensitive = true;
   phrasebuf->Encrypt(GetSessionKey());
   phrases->AddObject(idtext8,phrasebuf);
   Timer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPassphrase::Delete(AnsiString idtext8)
{
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   int idx; if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      delete (TDataBuf*)phrases->Objects[idx];
      phrases->Delete(idx);
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(AnsiString idtext8)
{
   AnsiString phrase;
   if (idtext8.Pos("0x")==1) idtext8 = idtext8.SubString(3,8);
   int idx; if ((idx=phrases->IndexOf(idtext8))>=0)
   {
      TDataBuf *phrasebuf = (TDataBuf*)phrases->Objects[idx];
      phrasebuf->Decrypt(GetSessionKey());
      phrase = phrasebuf->str();
   }
   return phrase;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPassphrase::Get(TStrings *idtext8s, AnsiString &idtext8)
{
   AnsiString phrase;
   for (int i=0; i<idtext8s->Count; i++)
   {
      idtext8 = idtext8s->Strings[i];
      if ((phrase=Get(idtext8))!="")
         break;
   }
   return phrase;
}
//---------------------------------------------------------------------------

