/*
*  PgpPath.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpPath.h"
AnsiString PgpPath;
bool PGPscInited=false;
//---------------------------------------------------------------------------
AnsiString __fastcall PGPpath(TForm *Owner)
{
   if (PGPscInited) return PgpPath;
   HINSTANCE hPGPsc = LoadLibrary("pgpsc.dll");
   if (!hPGPsc) hPGPsc = LoadLibrary("pgp60sc.dll");
   if (!hPGPsc) return "";
   TPGPsc *pgpsc = new TPGPsc(Owner,hPGPsc);
   if (pgpsc->ok) PgpPath = pgpsc->GetPGPpath();
   delete pgpsc;
   if (hPGPsc) FreeLibrary(hPGPsc);
   return PgpPath;
}
//---------------------------------------------------------------------------
__fastcall TPGPsc::TPGPsc(TForm *Owner, HINSTANCE hPGPsc)
{
   owner = Owner; hpgpsc = hPGPsc;
   ok = InitPGPsc(Owner->Handle,&pgpsc,&pgptls);
   PGPscInited = true;
}
//---------------------------------------------------------------------------
__fastcall TPGPsc::~TPGPsc()
{
   UninitPGPsc(owner->Handle,pgpsc,pgptls);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPGPsc::GetPGPpath()
{
   if (!ok) return "";
   char *path = new char[MAX_PATH];
   PGPpath(path); pgppath = path;
   delete path;
   return pgppath;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPsc::InitPGP55sc(HWND hwnd,void **PGPsc)
{
   bool ret=false; INITPGP55SC init;
   if ((init=(INITPGP55SC)GetProcAddress(hpgpsc,"InitPGPsc"))!=NULL)
      ret = (init)(hwnd,PGPsc);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPsc::UninitPGP55sc(HWND hwnd,void *PGPsc)
{
   bool ret=false; UNINITPGP55SC uninit;
   if ((uninit=(UNINITPGP55SC)GetProcAddress(hpgpsc,"UninitPGPsc"))!=NULL)
      ret = (uninit)(hwnd,PGPsc);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPsc::InitPGPsc(HWND hwnd,void **PGPsc,void **PGPtls)
{
   bool ret=false; INITPGPSC init;
   if ((init=(INITPGPSC)GetProcAddress(hpgpsc,"InitPGPsc"))!=NULL)
      ret = (init)(hwnd,PGPsc,PGPtls);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall TPGPsc::UninitPGPsc(HWND hwnd,void *PGPsc,void *PGPtls)
{
   bool ret=false; UNINITPGPSC uninit;
   if ((uninit=(UNINITPGPSC)GetProcAddress(hpgpsc,"UninitPGPsc"))!=NULL)
      ret = (uninit)(hwnd,PGPsc,PGPtls);
   return ret;
}
//---------------------------------------------------------------------------
void __fastcall TPGPsc::PGPpath(char* szPath)
{
   PGPPATH pgppath;
   if ((pgppath=(PGPPATH)GetProcAddress(hpgpsc,"PGPpath"))!=NULL)
      (pgppath)(szPath);
}
//---------------------------------------------------------------------------
