/*
*  PgpRecipDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef PgpRecipDlgsH
#define PgpRecipDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>

#include "pgp.h"
#include "pgpbuffers.h"
//---------------------------------------------------------------------------
const bool NotConventional = false;
const AnsiString UseConventional = "use conventional";
bool __fastcall PGPgetEncryptList(TStrings *Recipients, bool AllowConventional=true);

typedef struct {
  byte Type;
  AnsiString IdText8;
  byte Version;
  long TimeStamp;
  int Validity;
  byte sigtype;
  long sigtime;
  byte hash[16];
} KeyInfo;

class TPgpRecipDlg : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TPanel *Panel3;
  TListBox *ListBox1;
  THeaderControl *HeaderControl1;
  TPanel *Panel4;
  TPanel *Panel5;
  THeaderControl *HeaderControl2;
  TListBox *ListBox2;
  TPanel *Panel2;
  TPanel *Panel6;
  TLabel *Label1;
  TPanel *Panel7;
  TGroupBox *GroupBox1;
  TCheckBox *CheckBox1;
  TCheckBox *Conventional;
  TCheckBox *CheckBox3;
  TButton *OkBtn;
  TButton *CancelBtn;
  TRadioButton *MyKeys;
  TRadioButton *RemKeys;
  TBevel *Bevel1;
  TCheckBox *SortBox;
  TTimer *Timer1;
  void __fastcall ListBox1DblClick(TObject *Sender);
  void __fastcall ListBox2DblClick(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall ConventionalClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall ListBox2DragOver(TObject *Sender, TObject *Source, int X,
     int Y, TDragState State, bool &Accept);
  void __fastcall ListBox2DragDrop(TObject *Sender, TObject *Source, int X,
     int Y);
  void __fastcall ListBox1DragDrop(TObject *Sender, TObject *Source, int X,
     int Y);
  void __fastcall ListBox1DragOver(TObject *Sender, TObject *Source, int X,
     int Y, TDragState State, bool &Accept);
  void __fastcall ListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
     TOwnerDrawState State);
  void __fastcall WhichKeysClick(TObject *Sender);
  void __fastcall SortBoxClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
  bool opendlg;
  TPGPbuffer *pubdb;
  TPGPbuffer *cpkdb;
  TStringList *To;
  TStringList *keys;
  TStrings *recips;
  virtual __fastcall TPgpRecipDlg(TComponent* Owner);
  virtual __fastcall TPgpRecipDlg(TComponent* Owner, TStrings *Recips,
     bool AllowConventional);
  __fastcall virtual ~TPgpRecipDlg();
  AnsiString __fastcall KeyStr(TPGPbuffer *key, int id);
  AnsiString __fastcall GetKeyStr(AnsiString &id);
  void __fastcall LoadPublics(TPGPbuffer *db);
};
//---------------------------------------------------------------------------
extern TPgpRecipDlg *PgpRecipDlg;
//---------------------------------------------------------------------------
#endif
